#ifndef __CONTROL_INTERNAL
#define __CONTROL_INTERNAL

/* These types/variables are only needed by the gui to be able to change
 * the inputs, no game driver should need those */

#ifdef __cplusplus
extern "C" {
#endif

#include "deftypes.h"

/* DEF_INPUT_EMU : these one on the other hand are gui only, which means that
 * one key press makes an action to happen immediately, we don't care if the
 * key stays down or not, and there are no custom controls for this ->
 * we can add the function to execute in the struct */
typedef struct DEF_INPUT_EMU
{
   UINT32 scancode;
   UINT32 joycode;
   char *name;
   void  (*proc)();
} DEF_INPUT_EMU;

/* This is the "direct mapping" of the joystick or digital, that is moved or
 * not moved, nothing in the middle. For "analog" mode, we'll add something
 * different (new type of input probably). So the weird way to handle joystick
 * axes... */
#define JOY(NUM_JOY, AXE, BUTTON, HAT_NUM) \
  (NUM_JOY) | (AXE<<8) | ((BUTTON)<<16) | ((HAT_NUM)<<24)
/* Notice : which must start at 1 otherwise joystick1 left is mapeed to 0
 * which is equivalent to no mapping.
 * Same thing for button number which must start at 1
 * and probably the hat number too (not tested yet !) */

#define AXE_LEFT(NUM) (NUM*2)
#define AXE_RIGHT(NUM) (NUM*2+1)

   /* Use this way : HAT(1,SDL_HAT_UP)
      the positions are a bit mask in sdl from 0 to 8, it should not change
      soon, so it uses the first 4 bits in this byte. The upper 4 bits are the
      hat number but I don't expect to have so many hats one day ! */
#define HAT(NUM,POS) ((NUM<<4)|pos)

#define MAX_AXIS 16
#define MAX_JOY 16

extern struct DEF_INPUT_EMU def_input_list_emu[];

#ifdef __cplusplus
}
#endif

#endif

