#include "../gui/menu.h"
#include "raine.h" // display_cfg
#include "video_info.h"
#include "blit.h"

static menu_item_t video_items[] =
{
{  "Video renderer", NULL, (int*)&display_cfg.video_mode, 3, {0, 1, 2},
  { "Autodetect : hw YUV overlays / normal blits", "Force YUV overlays (can be slow!)",
    "Force normal blits"} },
{ "Video info...", &do_video_info, },
{ "YUV overlays:" },
{ "Fix aspect ratio to 4:3", NULL, (int*)&display_cfg.fix_aspect_ratio, 2, {0,1}, {"No", "Yes" } },
{ "Normal blits:" },
{ "Change video mode", NULL, (int*)&display_cfg.auto_mode_change, 3, {0, 1, 2},
  { "Never", "To match game resolution (low res most of the time)", "To match 2x game resolution" } },
{ "Scale game screen", NULL, (int*)&display_cfg.stretch, 3, { 0, 1, 2 }, 
  { "Never", "use scale2x when needed (MMX optimized)", "use scale2x/3x when needed (3x is pure C - slower)" } },
{ "Scanlines", NULL, (int*)&display_cfg.scanlines, 3, { 0, 1, 2 },
  { "Off", "Halfheight", "Fullheight" } },
{ "General options:" },
{ "Limit framerate <= 60fps", NULL, (int*)&display_cfg.limit_speed, 2, {0, 1}, {"No","Yes"} },
{ "Frame skip", NULL, (int*)&display_cfg.frame_skip, 10, {0, 1, 2, 3, 4, 5, 6, 7, 8, 9},
  {"Auto", "1", "2", "3", "4", "5", "6", "7", "8", "9" } },
{ "Screen rotation", NULL, (int*)&display_cfg.user_rotate, 4, {0, 1, 2, 3 },
  { "None", "90", "180", "270" } },
{ "Flip scren", NULL, (int*)&display_cfg.user_flip, 4, {0, 1, 2, 3 },
  { "None", "Flip X", "Flip Y", "Flip XY" } },
{  NULL },
};

int do_video_options() {
  TMenu *video_options = new TMenu("Video options", video_items);
  video_options->execute();
  SetupScreenBitmap();
  return 0;
}

